<?php
	//Get system name
	if(file_exists("backend/name.txt") && file_get_contents("backend/name.txt") != "")
	{
		$sysname=file_get_contents("backend/name.txt") . " ";
	}
	else
	{
		$sysname="";
	}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
  <head>
    <meta http-equiv="content-type" content="text/html; charset=utf-8">
    <meta name="generator" content="CoffeeCup HTML Editor (www.coffeecup.com)">
    <meta name="created" content="Wed, 17 Jun 2015 12:33:52 GMT">
    <meta name="description" content="Listening to a live stream? Got a song you have to hear? This is the place to request it!">
	<link rel="shortcut icon" href="backend/favicon.ico">
    <title><?php echo $sysname; ?>Music Request System-Report Request</title>
    
    <style type="text/css">
    <!--
    body {
      color:#000000;
	  background-color:#FFFFFF;
      background-image:url('backend/background.gif');
      background-repeat:repeat;
    }
    a  { color:#FFFFFF; background-color:#0000FF; }
    a:visited { color:#FFFFFF; background-color:#800080; }
    a:hover { color:#000000; background-color:#00FF00; }
    a:active { color:#000000; background-color:#FF0000; }
    -->
    </style>
  </head>
  <body>
  <?php
	//Function for determining if user is banned
	function is_banned()
	{
        if(file_exists("ban/ip.txt"))
        {
            $iplist=file_get_contents("ban/ip.txt");
        }
        else
        {
            $iplist="";
        }
		$ip=$_SERVER['REMOTE_ADDR'];
		if(strpos($iplist,$ip) === false)
		{
			return false;
		}
		return true;
	}
	
  	if(file_exists("backend/logging.txt") && file_get_contents("backend/logging.txt") == "yes")
	{
		//Change the timezone
		if(file_exists("backend/timezone.txt"))
		{
			date_default_timezone_set(file_get_contents("backend/timezone.txt"));
		}
		else
		{
			date_default_timezone_set("America/Toronto");
		}
		//Logging enabled
		$ip=$_SERVER['REMOTE_ADDR'];
		$fh=fopen("log/" . date("Ymd") . ".txt",'a') or die("Backend failure.");
		if($_POST['confirm'] == "y")
		{
			//Write email string
			$string="Post #" . $_POST['id'] . ", written by \"" . $_POST['name'] . "\" (" . $_POST['ip'] . ") on " . $_POST['date'] . " was reported by a user with IP address " . $_POST['uip'] . " on " . $_POST['rdate'] . ".\r\n";
			$string.="Request content: " . $_POST['request'] . "\r\n";
			//NOTE: trim whitespace before sanitizing!
			$string.="Report comment: " . trim($_POST['comment']);
			//Sanitize string
			$string=filter_var($string,FILTER_SANITIZE_EMAIL);
			//Get the email address to send the request to
			if(file_exists("backend/email.txt") && file_get_contents("backend/email.txt") != "")
			{
				//Use the supplied email
				$email=base64_decode(file_get_contents("backend/email.txt"));
				$date=date("g:i:s");
				fwrite($fh,$ip . " at " . $date . ": Obtained email address to send report to\r\n");
			}
			else
			{
				//Use the supplied email
				$email="lowendradiorequests@gmail.com";
				$date=date("g:i:s");
				fwrite($fh,$ip . " at " . $date . ": No email address found, assuming default\r\n");
			}
			//Send email
			$debug=mail($email,"Reported request on MRS",$string,"From: lowendradiorequests@gmail.com");
			if($debug === true)
			{
				//Success
				$date=date("g:i:s");
				fwrite($fh,$ip . " at " . $date . ": Successfully sent email for report " . $_POST['id'] . "\r\n");
			}
			else
			{
				//Failure
				$date=date("g:i:s");
				fwrite($fh,$ip . " at " . $date . ": Failed to email for report " . $_POST['id'] . "\r\n");
			}
			fclose($fh);
			//Get out of here
			echo ("<script type=\"text/javascript\">window.location = \"index.php\"</script>");
		}
		elseif(is_banned() === false)
		{
			//Get file info
			$date=date("g:i:s");
			fwrite($fh,$ip . " at " . $date . ": Visited report page for post \"" . $_GET['p'] . "\"\r\n");
			if(file_exists("posts/" . $_GET['p'] . ".txt"))
			{
				//Post exists
				$date=date("g:i:s");
				fwrite($fh,$ip . " at " . $date . ": Obtained details for post \"" . $_GET['p'] . "\"\r\n");
				$contents=explode("\r\n",base64_decode(file_get_contents("posts/" . $_GET['p'] . ".txt")));
			}
			else
			{
				//Post does not exist
				fwrite($fh,$ip . " at " . $date . ": Encountered error obtaining details for post \"" . $_GET['p'] . "\"\r\n");
				fclose($fh);
				die("Failed to obtain request information.");
			}
			fclose($fh);
		}
		else
		{
			//User is banned
			$date=date("g:i:s");
			fwrite($fh,$ip . " at " . $date . ": Visited report page for post \"" . $_GET['p'] . "\"\r\n");
			fclose($fh);
			die("You are not authorized to report this post. <a href=\"index.php\">Click here</a> to go back.");
		}
	}
	else
	{
		//Logging disabled
		if($_POST['confirm'] == "y")
		{
			//Write email string
			$string="Post #" . $_POST['id'] . ", written by \"" . $_POST['name'] . "\" (" . $_POST['ip'] . ") on " . $_POST['date'] . " was reported by a user with IP address " . $_POST['uip'] . " on " . $_POST['rdate'] . ".\r\n";
			$string.="Request content: " . $_POST['request'] . "\r\n";
			//NOTE: trim whitespace before sanitizing!
			$string.="Report comment: " . trim($_POST['comment']);
			//Sanitize string
			$string=strip_tags($string);
			//Get the email address to send the request to
			if(file_exists("backend/email.txt") && file_get_contents("backend/email.txt") != "")
			{
				//Use the supplied email
				$email=base64_decode(file_get_contents("backend/email.txt"));
			}
			else
			{
				//Use the default email
				$email="lowendradiorequests@gmail.com";
			}
			//Send email
			mail($email,"Reported request on MRS",$string,"From: lowendradiorequests@gmail.com");
			//Get out of here
			echo ("<script type=\"text/javascript\">window.location = \"index.php\"</script>");
		}
		elseif(is_banned() === false)
		{
			//Get file info
			if(file_exists("posts/" . $_GET['p'] . ".txt"))
			{
				//Post exists
				$contents=explode("\r\n",base64_decode(file_get_contents("posts/" . $_GET['p'] . ".txt")));
			}
			else
			{
				//Post does not exist
				die("Failed to obtain request information.");
			}
		}
		else
		{
			//User is banned
			die("You are not authorized to report this post. <a href=\"index.php\">Click here</a> to go back.");
		}
	}
  ?>
  <h1 style="text-align:center; text-decoration:underline;"><?php echo $sysname; ?>Music Request System-Report Post #<?php echo $contents[0]; ?></h1>
  <form method="post" action="report.php">
  <input type="hidden" name="confirm" value="y">
  <input type="hidden" name="id" value="<?php echo $contents[0]; ?>">
  <input type="hidden" name="name" value="<?php echo $contents[1]; ?>">
  <input type="hidden" name="ip" value="<?php echo $contents[2]; ?>">
  <input type="hidden" name="date" value="<?php echo $contents[3]; ?>">
  <input type="hidden" name="uip" value="<?php echo $_SERVER['REMOTE_ADDR']; ?>">
  <input type="hidden" name="rdate" value="<?php echo date("m/d/Y g:i A"); ?>">
  Request to report: <input type="text" name="request" value="<?php echo $contents[4]; ?>" readonly="readonly"><br>
  Comments:<br>
  <textarea name="comment" required="required" rows="10" cols="50"></textarea><br>
  <input type="submit" value="Confirm"> or <input type="button" value="Cancel" onclick="window.location.href='index.php'">
  </form>
  </body>
</html>